# -*- coding: utf-8 -*-
"""
Created on Tue Jan  3 20:12:34 2023

@author: kjs98
"""

#다음 코드는 '경제'라는 주제의 네이버 기사에 대한 제목, 언론사에 대한 수집
import requests
from bs4 import BeautifulSoup

#소캣 연결 실패시 생기는 에러를 해결하기 위한 명령어
headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/104.0.0.0 Safari/537.36'}
raw = requests.get("https://search.naver.com/search.naver?where=news&query=경제",
                   headers={'User-Agent':'Mozilla/5.0'})
soup = BeautifulSoup(raw.text, "html.parser")

articles = soup.select('ul.list_news > li')

for ar in articles:
    title = ar.select_one("a.news_tit").text
    source = ar.select_one("a.info").text
    
    print(title, source) #해당 페이지에 대한 정보를 수집가능


#아래는 특정 기사의 내용 및 댓글 수집을 위한 코드
#conda install selenium
import requests
from bs4 import BeautifulSoup
from selenium import webdriver
import time

#소캣 연결 실패시 생기는 에러를 해결하기 위한 명령어
headers = {'User-Agent': 'Mozilla/5.0 (Windows NT 10.0; Win64; x64) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/104.0.0.0 Safari/537.36'}
res = requests.get('https://n.news.naver.com/article/023/0003710900?sid=101', headers=headers)
soup = BeautifulSoup(res.content, 'html.parser')

title = soup.find('title')
#기사 본문에서 우클릭 -> 검사를 통해 클래스확인
article_raw = soup.select('div#ct.newsct > div#contents.newsct_body > div#newsct_article.newsct_article._article_body')
#텍스트만 뽑아내기 위한 함수
article = [article.text for article in article_raw]

print("기사 제목 : " + title.get_text())
print(article)

#버전에 맞는 크롬드라이버 설치 후 파이썬파일과 같은 폴더에 압축풀기
#아래 함수는 크롬드라이버의 경로가 자꾸 해제?되어서 경로를 고정하기 위해 절대경로로 설정
driver = webdriver.Chrome(r"C:\Users\kjs98\OneDrive - 한양대학교\바탕 화면\강의\chromedriver.exe")
#driver = webdriver.Chrome('./chromedriver.exe')
#파싱되는 시간을 설정. 과부하 방지
url = 'https://n.news.naver.com/article/comment/023/0003710900' #댓글 페이지의 url
driver.implicitly_wait(30)
driver.get(url)

#댓글을 전부 불러오기위해 반복문 사용
while True:
    try:
        더보기 = driver.find_element_by_css_selector('span.u_cbox_page_more') #더보기의 html코드대입
        더보기.click()
        time.sleep(1)
    except:
        break
    
contents = driver.find_elements_by_css_selector('span.u_cbox_contents') #댓글만 추출
#아래는 작성자, 공감수, 답글 등도 추출
#contents = driver.find_elements_by_css_selector('div#cbox_module_wai_u_cbox_content_wrap_tabpanel.u_cbox_content_wrap')
for content in contents:
    print(content.text)
#전체 댓글 수와 추출된 댓글의 수가 다른 이유는 클린봇이 부적절한 댓글을 지웠기 때문. 클린봇설정에 따라 전체추출가능